using System.ComponentModel;
using Spectre.Console.Cli;

namespace Automancer.Command.Image;

public class BuldSettings: CommandSettings
{
    [CommandArgument(0, "[path]")]
    [Description("Path to the Dockerfile")]
    public string? Path { get; set; }

    [CommandOption("-t|--tag")]
    [Description("Tag to use for the image")]
    public string? Tag { get; set; }

    [CommandOption("-f|--file")]
    [Description("Path to the Dockerfile")]
    public string? File { get; set; }

    [CommandOption("--push")]
    [Description("Push the image after building it")]
    public bool Push { get; set; }
}

public class BuildCommand : Command<BuldSettings>
{
    public override int Execute(CommandContext context, BuldSettings settings)
    {
        Console.WriteLine($"Building image from {settings.Path} with tag {settings.Tag}");

        return 0;
    }
}

